/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Classic Menus extension.
 *
 * The Initial Developer of the Original Code is
 * "The MozillaZine Community".
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 *  supernova_00, 0live, pljones, Elfguy, dbMorris, ColdFusion650,
 *  Ben Basson (Cusser), Regis Caspar, BoxerBoi76, Nanaki, mw.
 *
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

 
var regkey = Components.classes["@mozilla.org/windows-registry-key;1"]
                       .createInstance(Components.interfaces.nsIWindowsRegKey);

function checkOS()
{
  try 
  {
    regkey.open(Components.interfaces.nsIWindowsRegKey.ROOT_KEY_LOCAL_MACHINE,
                'SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion',
                Components.interfaces.nsIWindowsRegKey.ACCESS_READ);
    var productname = regkey.readStringValue("ProductName");
    regkey.close();
    return productname;
  } 
  catch(ex)
  {
    regkey.close();
    Components.reportError(ex);
    return '';
  }
}


function checkTheme()
{
  try 
  {
    regkey.open(Components.interfaces.nsIWindowsRegKey.ROOT_KEY_CURRENT_USER,
                'Software\\Microsoft\\Windows\\CurrentVersion\\ThemeManager',
                Components.interfaces.nsIWindowsRegKey.ACCESS_READ);
    var themeactive = regkey.readStringValue("ThemeActive");
    regkey.close();
    return themeactive;
  }
  catch(ex) 
  {
    regkey.close();
    Components.reportError(ex);
    return 0;
  }
}


function installTheme(url)
{
   var sss = Components.classes["@mozilla.org/content/style-sheet-service;1"]
                       .getService(Components.interfaces.nsIStyleSheetService);
   var ios = Components.classes["@mozilla.org/network/io-service;1"]
                       .getService(Components.interfaces.nsIIOService);
   var u = ios.newURI(url, null, null);
   if(!sss.sheetRegistered(u, sss.USER_SHEET)) {
     sss.loadAndRegisterSheet(u, sss.USER_SHEET);
}

  var link = document.createElementNS('http://www.w3.org/1999/xhtml', 'link');
  link.rel = 'stylesheet';
  link.type = 'text/css';
  link.href = url;
  document.documentElement.appendChild(link);
}


// from greasemonkey 'prefmanager.js' (sligthly modified)
function getPref(name, defval)
{
  var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                        .getService(Components.interfaces.nsIPrefService)
                        .getBranch("extensions.classicmenus.");
  var type = prefs.getPrefType(name);

  if (type == prefs.PREF_INVALID) 
    return defval;
    
  switch (type) {
    case prefs.PREF_STRING:
      return prefs.getCharPref(name);
    case prefs.PREF_BOOL:
      return prefs.getBoolPref(name);
    case prefs.PREF_INT:
      return prefs.getIntPref(name);
    default:
        return defval;
  }
}


function loadClassicMenus ()
{
  var theme;
  var tweak = getPref("ThemeActive", 2);
  
  if (tweak == 2)
    theme = (checkOS() == 'Microsoft Windows XP')?checkTheme():0;
  else 
    theme = tweak;
  
  if (theme == 0) 
  {
    var themeurl = getPref("ThemeURL", 'chrome://classicmenus/skin/menu.css');
    installTheme(themeurl);
  } 
}


window.addEventListener("load",loadClassicMenus,false);