/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Classic Menus extension.
 *
 * The Initial Developer of the Original Code is
 * "The MozillaZine Community".
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 *  supernova_00, 0live, pljones, Elfguy, dbMorris, ColdFusion650,
 *  Ben Basson (Cusser), Regis Caspar, BoxerBoi76, Nanaki, mw.
 *
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 
var bundle; 
 
function init()
{
  setTextboxValue();
  var ButtonBox = document.getElementById('ClassicMenu-optionsDialog')
                          .getButton('extra2').parentNode;
  ButtonBox.setAttribute('style', '-moz-padding-start: 8px');
  bundle = document.getElementById("bundle");
}


function setTextboxValue()
{
  var box = document.getElementById('themefile');
  var pref = document.getElementById('extensions.classicmenus.ThemeURL');
  box.value = pref.value;
}


function reloadChrome() 
{
  var auto = document.getElementById("extensions.classicmenus.AutoReloadChrome").value;
  
  if (auto)
  {
    try 
    {
      var XULCh = Components.classes["@mozilla.org/chrome/chrome-registry;1"]
                            .getService(Components.interfaces.nsIXULChromeRegistry)
                
      XULCh.reloadChrome();
    } 
    catch(ex) 
    { 
      Components.reportError(ex);
    }
  }
}


function resetToDefault()
{
  var prefs = document.getElementById('ClassicMenu-prefs').childNodes;
  for(var i = 0; i < prefs.length; i++)
    if (prefs[i].hasUserValue)
      prefs[i].reset();
  setTextboxValue();
}


function pickEditor() {
  const nsIFilePicker = Components.interfaces.nsIFilePicker;
  const nsIFileProtocolHandler = Components.interfaces.nsIFileProtocolHandler;
  var fp = Components.classes["@mozilla.org/filepicker;1"]
                     .createInstance(nsIFilePicker);
  var initdir = Components.classes["@mozilla.org/file/local;1"]
                          .createInstance(Components.interfaces.nsILocalFile);
  var ios = Components.classes['@mozilla.org/network/io-service;1']
                      .createInstance(Components.interfaces.nsIIOService);
  var fh = ios.getProtocolHandler("file").QueryInterface(nsIFileProtocolHandler);
  var customApp = document.getElementById("themefile");
  if (!customApp)
    return false;  
  fp.init(window, bundle.getString('filepicker.title'), nsIFilePicker.modeOpen);
  fp.appendFilter(bundle.getString('filepicker.cssfilter'), "*.css");
  fp.appendFilters(nsIFilePicker.filterAll);
  if (fp.show() == nsIFilePicker.returnOK && fp.file) {
    var textbox = document.getElementById('themefile');
    var pref = document.getElementById('extensions.classicmenus.ThemeURL');
    var URI = pref.value;
    try
    {
      URI = fh.getURLSpecFromFile(fp.file);
    }
    catch(ex) 
    {
      Components.reportError(ex);
      return false;
    }
    pref.value = URI;
    textbox.value = fp.file.path;
    return true;
  }
  return false;
}


window.addEventListener("load", init, false);